﻿:Namespace Dates

     ∇ r←CookieFmt date;day;date;mon
[1]   ⍝ Format date for cookie expiry
[2]   ⍝ "expires Mon, 09-Dec-2002 13:46:00 GMT"
[3]
[4]    day←(7 3⍴'MonTueWedThuFriSatSun')[WeekDay date;]
[5]    mon←(12 3⍴'janfebmaraprmayjunjulaugsepoctnovdec')[2⊃date;]
[6]    r←,('<',day,', >,ZI2,<-',mon,'->,ZI4,< >,ZI2,<:>,ZI2,<:>,ZI2,< GMT>')⎕FMT 1 5⍴(6↑date)[3 1 4 5 6]
     ∇ 
  
     ∇ SM←DateToIDN TS;⎕ML;YY;MM;DD;LP;DDM  ⍝ Convert date format : (IDN) ← 3↑⎕TS  (aka SM_TS)
[1]    ⎕ML←0                                ⍝ Native Dyalog.
[2]    YY MM DD←3↑TS                        ⍝ Split args.
[3]    LP←-/0=400 100 4|YY                  ⍝ Leap year.
[4]    DDM←0 31,LP+59 90 120 151 181 212 243 273 304 334     ⍝ Days by month.
[5]    SM←⌊365.25×YY-1900                   ⍝ Convert years.
[6]    SM+←⊃MM↓0,DDM                        ⍝   ..    months.
[7]    SM+←DD-LP                            ⍝   ..    days.
[8]    SM+←SM<0                             ⍝ Days before 1900-01-01 are ≤ 0.
[9]
[10]   :If 3<⍴TS
[11]       SM←SM+24 60 60 1000{(⍺⊥4↑3↓⍵)÷×/⍺}TS
[12]   :EndIf
     ∇ 

     ∇ TS←IDNToDate SM;⎕ML;LP;MM;DD;YY;DAY;DDM;D;T  ⍝ Convert IDN to date format : 3↑⎕TS ← IDN (akd TS_SM)
[1]    ⎕ML←0                                ⍝ Native Dyalog.
[2]    T←SM-D←⌊SM                           ⍝ Time and Day
[3]    YY DAY←1900 0+⌈0 365.25⊤D-D<1      ⍝ Year since 1900 and day.
[4]    LP←-/0=400 100 4|YY                  ⍝ Leap year.
[5]    DDM←0 31,LP+59 90 120 151 181 212 243 273 304 334         ⍝ Days by month.
[6]    DD←DAY+LP                            ⍝ Add in leap day.
[7]    MM←+/DDM<DD                          ⍝ Month.
[8]    DD-←⊃MM↓0,DDM                        ⍝ Day.
[9]    TS←YY MM DD                          ⍝ Collect result.
[10]   TS←TS,⌊0.5+24 60 60 1000{⍺⊤(×/⍺)×⍵}T
     ∇  

     ∇ r←Now
[1]    r←Int_TS ⎕TS
     ∇  

     ∇ r←TSFmtNice ts;now;yday;today;z;i;m;idn;s
[1]   ⍝ Format a vector of IDN's nicely
[2]
[3]    s←⍴ts
[4]    yday←¯1+today←⌊now←DateToIDN ⎕TS
[5]    r←↑IDNToDate¨,ts←,ts ⍝ Make matrix
[6]
[7]    r←'ZI4,<->,ZI2,<->,ZI2,< >,ZI2,<:>,ZI2'⎕FMT 5↑[2]r
[8]
[9]    :If 0≠⍴i←((ts≥yday)∧~m←ts≥today)/⍳⍴ts
[10]       r[i;]←r[i;11+⍳5],' ',((⍴i),10)⍴10↑'Yesterday'
[11]   :EndIf
[12]
[13]   :If 0≠⍴i←m/⍳⍴ts
[14]       r[i;]←r[i;11+⍳5],' ',((⍴i),10)⍴10↑'Today'
[15]   :EndIf
[16]
[17]   :If 0≠⍴i←(100>z←⌊(now-ts)×24×60)/⍳⍴ts
[18]       r[i;]←16↑[2]↑(⍕¨⌊z[i]),¨(' minutes ago' ' minute ago')[1+1=z[i]]
[19]   :EndIf
[20]
[21]   :If 0≠⍴i←(z<1)/⍳⍴ts
[22]       r[i;]←((⍴i),16)⍴16↑'Now'
[23]   :EndIf
[24]
[25]   r←(s,¯1↑⍴r)⍴r
     ∇  

     ∇ r←WeekDay Date
[1]    ⍝ Return weekday (Monday=1, Sunday=7)
[2]
[3]    r←1+7|(DateToIDN 3↑Date)-1
     ∇

:EndNamespace