﻿:Namespace HTMLInput

    ⎕IO ⎕ML←1 0
    ⎕FX 'r←CRLF' 'r←⎕UCS 13 10' ⍝ So it will be :Included
    enlist←{⎕ML←2 ⋄ ∊⍵} ⍝ APL2 enlist
    eis←{2>|≡⍵:,⊂⍵ ⋄ ⍵} ⍝ Enclose if simple
    ⍝ /// Add "Num" function

    ∇ r←name CheckBox pars
      ⍝ pars: checked [attributes]
     
      pars←pars,(⍴,pars)↓0 ''
      r←'<input ',(2⊃pars),' type=checkbox name=',name,(0≠1⊃pars)/' checked=1'
      r←r,'>',CRLF
    ∇

    ∇ r←JS script⍝ Javascript
      r←'<script type="text/javascript">',CRLF,script,CRLF,'</script>'
    ∇

    ∇ r←name DropDown pars
      ⍝ items value attributes sort
     
      pars←pars,(⍴pars)↓('Item1' 'Item2')'Item1' '' 0
         ⍝ (3⊃pars)←{1=≡⍵:⊂⍵ ⋄ ⍵}3⊃pars
      :If 4⊃pars ⋄ (1⊃pars)←(1⊃pars)[⍒(1⊃pars)∊eis 2⊃pars] ⋄ :EndIf ⍝ Sort selected items first
      r←'<select ',(3⊃pars),' id="',name,'" name="',name,'" value="',(2⊃pars),'"'
      r←r,'>',CRLF
      r←r,enlist('<option>' '<option selected>')[1+(1⊃pars)∊pars],¨(1⊃pars),¨⊂'</option>',CRLF
      r←r,'</select>',CRLF
    ∇

    ∇ r←{atts}(method Form)innerhtml
      :If 9=⎕NC'atts' ⋄ atts←'action="',atts.Page,'"' ⍝ MildPage calling
      :ElseIf 0=⎕NC'atts' ⋄ atts←'' ⋄ :EndIf
     
      atts,←' method="',method,'"'
      atts,←('post'≡#.Strings.lc method)/' enctype="multipart/form-data"'
     
      r←('form ',atts)Enclose innerhtml
    ∇

    ∇ r←name Edit pars ⍝ pars: value [size [attributes]]
     
      pars←,eis pars
      pars←pars,(⍴pars)↓'Edit'(10⌈⍴1⊃pars)''
      r←'<input ',(3⊃pars),' type=text size=',(⍕2⊃pars),' id="',name,'" name=',name,' value="',(1⊃pars),'"'
      r←r,'>',CRLF
    ∇

    ∇ r←atts Enclose innerhtml;i
    ⍝ Put an HTML tag around some HTML
     
      i←¯1+(atts←,atts)⍳' '
      r←'<',atts,'>',innerhtml,'</',(i↑atts),'>',CRLF
    ∇

    ∇ r←name Submit pars
 ⍝ pars: value [attributes]
     
      pars←,eis pars
      pars←pars,(⍴pars)↓'Push Me!' '' ''
      r←'<input type="submit" ',(2⊃pars),' name="',name,'" value="',(1⊃pars),'"'
      r←r,' >',CRLF
    ∇

    ∇ r←name Button pars
 ⍝ pars: value [attributes]
     
      pars←,eis pars
      pars←pars,(⍴pars)↓'Push Me!' '' ''
      r←'<input  type="button" ',(2⊃pars),' name="',name,'" value="',(1⊃pars),'"'
      r←r,' >',CRLF
    ∇

    ∇ r←name File pars
         ⍝ pars: size [value [attributes]]
     
      pars←,eis pars
      pars←pars,(⍴pars)↓10 '' ''
      r←'<input ',(3⊃pars),' type=file size=',(⍕1⊃pars),' id="',name,'" name=',name,' value="',(2⊃pars),'"'
      r←r,'>',CRLF
    ∇

    ∇ r←name Hidden pars
         ⍝ pars: size [value [attributes]]
     
      pars←,eis pars
      pars←pars,(⍴pars)↓'' ''
      r←'<input ',(2⊃pars),' type=hidden id="',name,'" name="',name,'" value="',(1⊃pars),'"'
      r←r,'>',CRLF
    ∇

    ∇ r←name Password pars
         ⍝ pars: size [value [attributes]]
     
      pars←pars,(⍴pars)↓'' 5 ''
      r←'<input ',(3⊃pars),' type=password size=',(⍕1⊃pars),' id="',name,'" name=',name,' value="',(2⊃pars),'"'
      r←r,'>',CRLF
    ∇

    ∇ r←name RadioButton pars
         ⍝ pars: checked [value [attributes]]
     
      pars←pars,(⍴,pars)↓0 name''
      r←'<input ',(3⊃pars),' type=radio name="',name,'" value="',(2⊃pars),'"',(0≠1⊃pars)/' checked'
      r←r,'> ',2⊃pars
    ∇

    ∇ r←{name}Table pars;x;data;atts;tdc;tda;thc;tha;hdrrows
 ⍝ pars: data table_atts cell_attribs header_attribs header_rows
     
      :If 0=⎕NC'name' ⋄ name←'' ⋄ :EndIf
      :If 2=⍴⍴pars ⋄ pars←,⊂pars ⋄ :EndIf ⍝ Matrix of data only
      pars←pars,(⍴,pars)↓(1 1⍴⊂'data')'' '' ''⍬
      data atts tda tha hdrrows←pars
      x←⍕¨data
      r←(⊂'<td ',tda,'>'),¨x,¨⊂'</td>'
      :If 0≠⍴,hdrrows
          r[hdrrows;]←(⊂'<th ',tha'>'),¨x[hdrrows;],¨⊂'</th>'
      :End
      r←'<tr>'∘,¨(,/r),¨⊂'</tr>',CRLF
      r←CRLF,'<table ',atts,'>',CRLF,(enlist r),CRLF,'</table>',CRLF
    ∇

    ∇ r←name MultiEdit pars
         ⍝ pars: (rows cols) [values [attributes]]
     
      pars←pars,(⍴pars)↓(10 40)'' ''
      r←'<textarea ',(3⊃pars),' id="',name,'" name="',name,'" rows="',(⍕1 1⊃pars),'" cols="',(⍕1 2⊃pars),'"'
      r←r,'>',CRLF,2⊃pars
      r←r,'</textarea>',CRLF
    ∇

:EndNamespace